'use strict';

const ModulusChecker = require('../lib/ModulusChecker.js'),
    assert = require('assert');

describe('ModulusChecker', function() {

    describe('check', function() {

        describe('correct account numbers', function() {

            it('Should return true for sort code 180002 and bank account number 98093517', function(done) {
                const modulusChecker = new ModulusChecker();

                assert(modulusChecker.check('180002', '98093517', [{
                    mod_check: 'MOD11',
                    u_multiplier: 0,
                    v_multiplier: 0,
                    w_multiplier: 0,
                    x_multiplier: 0,
                    y_multiplier: 0,
                    z_multiplier: 0,
                    a_multiplier: 8,
                    b_multiplier: 7,
                    c_multiplier: 6,
                    d_multiplier: 5,
                    e_multiplier: 4,
                    f_multiplier: 3,
                    g_multiplier: 2,
                    h_multiplier: 1,
                    exception: null
                }], null), true, 'Should return with true');
                done();
            });

            it('Should return true for sort code 180002 and bank account number 00000190', function(done) {
                const modulusChecker = new ModulusChecker();

                assert(modulusChecker.check('180002', '00000190', [{
                    mod_check: 'MOD11',
                    u_multiplier: 0,
                    v_multiplier: 0,
                    w_multiplier: 0,
                    x_multiplier: 0,
                    y_multiplier: 0,
                    z_multiplier: 0,
                    a_multiplier: 8,
                    b_multiplier: 7,
                    c_multiplier: 6,
                    d_multiplier: 5,
                    e_multiplier: 4,
                    f_multiplier: 3,
                    g_multiplier: 2,
                    h_multiplier: 1,
                    exception: 14
                }], null), true, 'Should return with true');
                done();
            });

        });

    });
});